/***
*  Pivot.mq4
*  Pivot Calculator
*  Written by: CrushD
****/

#property indicator_chart_window
#property indicator_buffers 6

#property indicator_color1 Green
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red

//---- input parameters\





// buffers

double CH3[];
double CH4[];
double CH5[];
double CL3[];
double CL4[];
double CL5[];

extern string StartTime = "06:00";
extern string EndTime = "05:45";
double ch3, ch4, ch5, cl3,cl4, cl5;
//double x;
double pivotOpen=0;
double pivotHigh=0;
double pivotLow=0;
double pivotClose=0;
double D1=0.091667;
double D2=0.183333;
double D3=0.2750;
double D4=0.55;
bool pivotStarted=false;
bool pivotCompleted=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
IndicatorShortName("Camarilla");

SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(0, CH3);
SetIndexLabel(0, "H3 Camarilla");

SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(1, CH4);
SetIndexLabel(1, "H4 Camarilla");

SetIndexStyle(2, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(2, CH5);
SetIndexLabel(2, "H5 Camarilla");

SetIndexStyle(3, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(3, CL3);
SetIndexLabel(3, "L3 Camarilla");

SetIndexStyle(4, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(4, CL4);
SetIndexLabel(4, "L4 Camarilla");

SetIndexStyle(5, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(5, CL5);
SetIndexLabel(5, "L5 Camarilla");


SetIndexDrawBegin(0,1);


return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{ 
   
return(0);
}
//--------------------------------------------------------


//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();


   for(int i=Bars; i>=0; i--)
   {
      calcPivots(i);
      CL3[i] = cl3;
      CL4[i] = cl4;
      CL5[i] = cl5;
      CH3[i] = ch3;
      CH4[i] = ch4;
      CH5[i] = ch5;      
   }
   
   
}

void calcPivots(int curBar)
{
   string barTime;
   
   barTime = TimeToStr(Time[curBar], TIME_MINUTES);
       
   if (barTime==StartTime)
   {
     pivotOpen = Open[curBar];
     pivotLow = Low[curBar];
     pivotHigh = High[curBar];
     pivotStarted=true;
   }

   if (pivotStarted && barTime==EndTime)
   {   
     pivotClose = Close[curBar];
     pivotCompleted=true; 
   }

   if (pivotStarted && pivotHigh<High[curBar])
   {
      pivotHigh=High[curBar];
   } 

   if (pivotStarted && pivotLow>Low[curBar]) 
   {
      pivotLow=Low[curBar];
   }  

   if (pivotCompleted)
   {
      ch5 = (pivotHigh/pivotLow)*pivotClose;
      ch4 = ((pivotHigh - pivotLow)* D4) + pivotClose;
      ch3 = ((pivotHigh - pivotLow)* D3) + pivotClose;
//ch2 = ((yesterday_high - yesterday_low) * D2) + yesterday_close;
//ch1 = ((yesterday_high - yesterday_low) * D1) + yesterday_close;

//cl1 = yesterday_close - ((yesterday_high - yesterday_low)*(D1));
//cl2 = yesterday_close - ((yesterday_high - yesterday_low)*(D2));
      cl3 = pivotClose - ((pivotHigh - pivotLow)*(D3));
      cl4 = pivotClose - ((pivotHigh - pivotLow)*(D4));     
      cl5 = pivotClose - (ch5 - pivotClose);
      
      pivotStarted = false;
      pivotCompleted = false; 
   }
   return(0);
}